
/* zaciatok 2.8.2000 18:47 (prestavka do 18:56)
   19:25 napisana textova verzia (medzicasom talk s mandosom)
   19:28 skompilovane bez warningov
   19:41 prisiel som na to kde som spravil debilnu chybu
   19:47 odladeny a funkcny textovy counter
   
   20:02 zacinam dorabat podporu virtualnych webservrov
   20:09 odladene oskusane, funkcne

   20:21 zacinam vylepsovat robenie locksuborov, kvoli symlinkom
   20:30 skompilovane, 
   20:37 odladene , funkcne
 */

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <fcntl.h>
#include <string.h>
#include <time.h>
#ifdef linux
#include <linux/limits.h>
#else
#include <limits.h>
#endif
#include <sys/stat.h>


#define	DIR	"/services/httpd/data/Mcounter"

/* create_lockfile
 * lockdir - adresar v ktorom sa vyrobi lockfile
 * lockname - meno lock suboru.
 * timeout - pocet sekund, kolko sa maximalne caka. Potom return(-1)
 *           if timeout<=0 then no timeout.
 * RETURN Value 0 ak ok
 */
int create_lockfile( char *lockdir, char *lockname, long timeout )
{ char fname[PATH_MAX];
  char buf[128];
  int fd,pid,l;
  time_t t;
  	t=time(NULL)+timeout;
	if( lockdir!=NULL )
		snprintf(fname,PATH_MAX,"%s/%s",lockdir,lockname);
	else	strncpy(fname,lockname,PATH_MAX);
	fname[PATH_MAX-1]=0;
	for(;timeout<=0 || time(NULL)<t;)
	{	
//printf("[%s]\n",fname);
		if( (fd=open(fname, O_WRONLY | O_CREAT | O_EXCL, 0600))<0 )
		{	if( (fd=open(fname,O_RDONLY))<0 ) continue;
			l=read(fd,buf,127);
			close(fd);
			if( l>0 )
			{	buf[l]=0;
				pid=atoi(buf);
				sprintf(buf,"/proc/%d",pid);
				if( access(buf, F_OK)<0 )
					unlink(fname);
				else	sleep(1);
			}
			else	sleep(1);
		}
		else
		{	sprintf(buf,"%d\n",getpid());
			write(fd,buf,strlen(buf));
			close(fd);
			return(0);
		}
	}
	return(-1);
}

/* delete_lockfile
 * return value as unlink
 */
int delete_lockfile( char *lockdir, char *lockname )
{ char fname[PATH_MAX];
	if( lockdir!=NULL )
		snprintf(fname,PATH_MAX,"%s/%s",lockdir,lockname);
	else	strncpy(fname,lockname,PATH_MAX);
	fname[PATH_MAX-1]=0;
	return(unlink(fname));
}
	
char *read_dest_file( char *name )
{ static char buf[PATH_MAX];
  static char buf2[PATH_MAX];
  char *p;
  struct stat s;
	strcpy(buf,name);
	for(;;)
	{
		if( lstat(buf,&s)<0 )
			return(buf);
		if( !S_ISLNK(s.st_mode) )
			return(buf);
		readlink(buf,buf2,PATH_MAX);
		if( (p=strrchr(buf,'/'))!=NULL )
			p++;
		else p=buf;
		if( *buf2=='/' )
			strcpy(buf,buf2);
		else	strcpy(p,buf2);
	}
}

int main( void )
{ char name[PATH_MAX];
  char buf[PATH_MAX];
  int fd,count;
  char *d,*l,*p;
	printf("Content-type: text/html\n\n");
	if( (d=getenv("DOCUMENT_URI"))==NULL || d[0]==0 )
		return(-1);
	for(p=buf;*d!=0;d++)
	{	if( *d=='/' )	{ *p++='_'; *p++='.'; }
		else if( *d=='_' )	{ *p++='_'; *p++='_'; }
		else if( *d=='~' )	{ *p++='_'; *p++='-'; }
		else	*p++=*d;
	}
	if( (p=getenv("HTTP_HOST"))==NULL )
		p="";
	strcpy(name,DIR);
	strcpy(name+strlen(name),"/");
	strcpy(name+strlen(name),p);
	strcpy(name+strlen(name),"/cnt.");
	strncpy(name+strlen(name),buf,PATH_MAX-strlen(name)-6);
	strcpy(name,read_dest_file(name));
	l=name+strlen(name);
	strcpy(l,".lock");
	if( create_lockfile(NULL,name,10)<0 )
	{	printf("[Sorry, internal counter problem!]");
		fflush(stdout);
		return(0);
	}
	*l=0;
	count=0;
	if( (fd=open(name, O_RDONLY))>=0 )
	{	if( read(fd,buf,128)>0 )
		{	count=atoi(buf);
		}
		close(fd);
	}
	count++;
	if( (fd=open(name, O_WRONLY | O_CREAT, 0600))<0 )
	{	printf("[Can't write counter state!]");
		fflush(stdout);
	}
	else
	{	sprintf(buf,"%d\n",count);
		write(fd,buf,strlen(buf));
		close(fd);
	}
	printf("%d",count);
	fflush(stdout);
	strcpy(l,".lock");
	delete_lockfile(NULL,name);
	return(0);
}

